Logo Questions Linux Laravel Mysql Ubuntu Git Menu
 

React Native - Port 8081 already in use, packager is either not running or not running correctly Command /bin/sh failed with exit code 2

I'm trying to get up and running with React Native and I am seeing the message below in Xcode:

Port 8081 already in use, packager is either not running or not running correctly

Command /bin/sh failed with exit code 2

I went to the React Native troubleshooting page and tried to kill the port 8081 processes, but I'm still getting the same issue.

Here is a screenshot of what I am seeing in Xcode:

error screenshots

Any help would be fully appreciated.

like image 556
user1454373 Avatar asked May 13 '15 13:05

user1454373


3 Answers

If you do lsof -n -i4TCP:8081 as recommended in Facebook's troubleshooting page and get an empty result, try again using sudo lsof -n -i4TCP:8081.

In my case, it turns out McAfee anti-virus software is running process that listens on that port. Killing that process (I know, I know!) fixed the problem.

like image 150
escouten Avatar answered Nov 03 '22 21:11

escouten


Try the following steps for those that need to change port 8081 to a different port.

> npm start

will launch node_modules/react-native/packager/packager.sh

In there it will merge command line parameters, i.e. --port into the predefined options. i.e. port=8081

I updated the package.json start option to include my prefered port, as i was unable to stop existing services using this port.

{
  "name": "AwesomeProject",
  "version": "0.0.1",
  "private": true,
  "scripts": {
    "start": "node_modules/react-native/packager/packager.sh --port=8999"
  },
  "dependencies": {
    "react-native": "^0.12.0"
  }
}

** Note that this may not work for android which is apparently hard coded to 8081 Stack Post Here

Building Xcode When building Xcode it will still fail as it tries to run a script to launch node. You will either need to remove this script from the build process or update it to the new port.

Under libraries select React.xcodeproj. In the main screen select Build Phases. You will see Run Script.

Either remove this entry, having called npm start yourself, or edit the port.

if nc -w 5 -z localhost 8999 ; then
  if ! curl -s "http://localhost:8999/status" | grep -q "packager-status:running" ; then
    echo "Port 8999 already in use, packager is either not running or not running correctly"
    exit 2
  fi
else
  open $SRCROOT/../packager/launchPackager.command || echo "Can't start packager automatically"
fi

Debugging Seems 8081 is all over the shop. Need to additionally updated the RCTWebSocketExecutor.m under xcode-project: Libraries/RCTWebSocket.xcodeproj

- (instancetype)init
{
  return [self initWithURL:[RCTConvert NSURL:@"http://localhost:8999/debugger-proxy"]];
}

** Launching packager from iOS ** If launching only from iOS then you additionally need to edit launchPackager.command to add in the appropriate port as this file is used by Xcode to run the javascript.

$THIS_DIR/packager.sh  --port=8999
like image 37
Emile Avatar answered Nov 03 '22 19:11

Emile


Easy method: Try with the following code

kill -9 $(lsof -t -i:8081)
like image 17
Arshid KV Avatar answered Nov 03 '22 19:11

Arshid KV